/*
 * KPIData.java
 */

package edu.ba.de.java.kpi;

import java.awt.*;

/**
 * @author  Raiden
 */
public class KPIData extends javax.swing.JFrame implements java.awt.event.ActionListener {
    /**
     * Dieser Konstruktor erzeugt eine neue Instanz.
     */
    public KPIData() {
        initComponents();
    }
    
    /** 
     * Diese Methode wird vom Konstruktor aufgerufen, um das Formular
     * zu erzeugen.
     *
     * WARNUNG: Diesen Quelltext nicht modifieren, da er von der
     *          Entwicklungswieder wieder neu erzeugt und dabei berschrieben
     *          wird.
     */
    // <editor-fold defaultstate="collapsed" desc=" Erzeugter Quelltext ">//GEN-BEGIN:initComponents
    private void initComponents() {
        ApplyButton = new javax.swing.JButton();
        CancelButton = new javax.swing.JButton();
        HostnameLabel = new javax.swing.JLabel();
        HostnameTextField = new javax.swing.JTextField();
        DatabasenameLabel = new javax.swing.JLabel();
        PortnumberTextField = new javax.swing.JTextField();
        TablenameLabel = new javax.swing.JLabel();
        DatabasenameTextField = new javax.swing.JTextField();
        PortnumberLabel = new javax.swing.JLabel();
        TablenameTextField = new javax.swing.JTextField();
        UsernameLabel = new javax.swing.JLabel();
        UsernameTextField = new javax.swing.JTextField();
        PasswordLabel = new javax.swing.JLabel();
        PasswordPasswordField = new javax.swing.JPasswordField();
        TopSeperator = new javax.swing.JSeparator();
        BottomSeperator = new javax.swing.JSeparator();
        CreateTableCheckBox = new javax.swing.JCheckBox();

        getContentPane().setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("KPI-Daten");
        setName("KPIDaten");
        ApplyButton.setText("Apply");
        ApplyButton.setName("ApplyButton");
        ApplyButton.addActionListener(this);

        getContentPane().add(ApplyButton, new org.netbeans.lib.awtextra.AbsoluteConstraints(120, 240, -1, -1));

        CancelButton.setText("Cancel");
        CancelButton.setName("CancelButton");
        CancelButton.addActionListener(this);

        getContentPane().add(CancelButton, new org.netbeans.lib.awtextra.AbsoluteConstraints(190, 240, -1, -1));

        HostnameLabel.setText("Hostname:");
        HostnameLabel.setName("HostnameLabel");
        getContentPane().add(HostnameLabel, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 10, -1, -1));

        HostnameTextField.setText("localhost");
        HostnameTextField.setName("HostnameTextField");
        getContentPane().add(HostnameTextField, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 30, 180, -1));

        DatabasenameLabel.setText("Databasename:");
        DatabasenameLabel.setName("DatabasenameLabel");
        getContentPane().add(DatabasenameLabel, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 60, -1, -1));

        PortnumberTextField.setText("3306");
        PortnumberTextField.setName("PortnumberTextField");
        getContentPane().add(PortnumberTextField, new org.netbeans.lib.awtextra.AbsoluteConstraints(200, 30, 60, -1));

        TablenameLabel.setText("Tablename:");
        TablenameLabel.setName("TablenameLabel");
        getContentPane().add(TablenameLabel, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 110, -1, -1));

        DatabasenameTextField.setText("kpi");
        DatabasenameTextField.setName("DatabasenameTextField");
        getContentPane().add(DatabasenameTextField, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 80, 250, -1));

        PortnumberLabel.setText("Portnumber:");
        PortnumberLabel.setName("PortnumberLabel");
        getContentPane().add(PortnumberLabel, new org.netbeans.lib.awtextra.AbsoluteConstraints(200, 10, -1, -1));

        TablenameTextField.setText("daten");
        TablenameTextField.setName("TablenameTextField");
        getContentPane().add(TablenameTextField, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 130, 140, -1));

        UsernameLabel.setText("Username:");
        UsernameLabel.setName("UsernameLabel");
        getContentPane().add(UsernameLabel, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 180, -1, -1));

        UsernameTextField.setText("root");
        UsernameTextField.setName("UsernameTextField");
        getContentPane().add(UsernameTextField, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 200, 120, -1));

        PasswordLabel.setText("Password:");
        PasswordLabel.setName("PasswordLabel");
        getContentPane().add(PasswordLabel, new org.netbeans.lib.awtextra.AbsoluteConstraints(140, 180, -1, -1));

        PasswordPasswordField.setName("PasswordPasswordField");
        getContentPane().add(PasswordPasswordField, new org.netbeans.lib.awtextra.AbsoluteConstraints(140, 200, 120, 20));

        TopSeperator.setName("TopSeperator");
        getContentPane().add(TopSeperator, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 160, 250, 10));

        BottomSeperator.setName("BottomSeperator");
        getContentPane().add(BottomSeperator, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 230, 250, 10));

        CreateTableCheckBox.setText("Create Table");
        CreateTableCheckBox.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        CreateTableCheckBox.setMargin(new java.awt.Insets(0, 0, 0, 0));
        CreateTableCheckBox.setName("CreateTableCheckBox");
        getContentPane().add(CreateTableCheckBox, new org.netbeans.lib.awtextra.AbsoluteConstraints(170, 130, 90, -1));

        pack();
    }

    // Quelltext zum Weiterleiten von Ereignissen von Komponenten zu Behandlungsmethoden.

    public void actionPerformed(java.awt.event.ActionEvent evt) {
        if (evt.getSource() == ApplyButton) {
            KPIData.this.ApplyButtonClicked(evt);
        }
        else if (evt.getSource() == CancelButton) {
            KPIData.this.CancelButtonClicked(evt);
        }
    }// </editor-fold>//GEN-END:initComponents

    /**
     * Diese Methode wird ausgefhrt, wenn auf den Button mit der Aufschritt
     * "Apply" gedrckt wird.
     * In diesem Fall wird das eigentliche Hauptfenster erzeugt, dessen
     * Parameter gesetzt und das Fenster angezeigt.
     */
    private void ApplyButtonClicked(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ApplyButtonClicked
        boolean lDone = false;
        KPIMain lForm = new KPIMain();

        lForm.setHost(HostnameTextField.getText());
        lForm.setPort(PortnumberTextField.getText());
        lForm.setDatabase(DatabasenameTextField.getText());
        lForm.setTable(TablenameTextField.getText());
        lForm.setUsername(UsernameTextField.getText());
        lForm.setPassword(String.valueOf(PasswordPasswordField.getPassword()));

        if (CreateTableCheckBox.isSelected()) {
            try {
                DataAccess.createDB(lForm.getHost(), lForm.getDatabase(), lForm.getPort(), lForm.getTable(), lForm.getUsername(), lForm.getPassword());
                
                lDone = true;
            }
            catch (Exception e) {Main.showError(e);}
        }
        else {
            lDone = true;
        }

        if (lDone) {
            try {
                lForm.showData();
                lForm.setVisible(true);

                setVisible(false);
                dispose();
            }
            catch (Exception e) {Main.showError(e);}      
        }
    }//GEN-LAST:event_ApplyButtonClicked

    /**
     * Diese Methode wird ausgefhrt, wenn auf den Button mit der Aufschritt
     * "Cancel" gedrckt wird.
     * In diesem Fall wird das derzeitige Fenster geschlossen.
     */    
    private void CancelButtonClicked(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_CancelButtonClicked
        dispose();
    }//GEN-LAST:event_CancelButtonClicked
    
    // Variablendeklaration - nicht modifizieren//GEN-BEGIN:variables
    protected javax.swing.JButton ApplyButton;
    protected javax.swing.JSeparator BottomSeperator;
    protected javax.swing.JButton CancelButton;
    protected javax.swing.JCheckBox CreateTableCheckBox;
    protected javax.swing.JLabel DatabasenameLabel;
    protected javax.swing.JTextField DatabasenameTextField;
    protected javax.swing.JLabel HostnameLabel;
    protected javax.swing.JTextField HostnameTextField;
    protected javax.swing.JLabel PasswordLabel;
    protected javax.swing.JPasswordField PasswordPasswordField;
    protected javax.swing.JLabel PortnumberLabel;
    protected javax.swing.JTextField PortnumberTextField;
    protected javax.swing.JLabel TablenameLabel;
    protected javax.swing.JTextField TablenameTextField;
    protected javax.swing.JSeparator TopSeperator;
    protected javax.swing.JLabel UsernameLabel;
    protected javax.swing.JTextField UsernameTextField;
    // Ende der Variablendeklaration//GEN-END:variables
}
